<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.metabolic.efm.adj.incore.tree.urank.modp;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import ch.javasoft.bitset.IBitSet;<a name="line.36"></a>
<FONT color="green">037</FONT>    import ch.javasoft.math.Prime;<a name="line.37"></a>
<FONT color="green">038</FONT>    import ch.javasoft.metabolic.efm.adj.incore.tree.urank.RankUpdateRoot;<a name="line.38"></a>
<FONT color="green">039</FONT>    import ch.javasoft.metabolic.efm.rankup.PreprocessableMatrix;<a name="line.39"></a>
<FONT color="green">040</FONT>    import ch.javasoft.metabolic.efm.rankup.PreprocessedMatrix;<a name="line.40"></a>
<FONT color="green">041</FONT>    import ch.javasoft.metabolic.efm.rankup.RankUpRoot;<a name="line.41"></a>
<FONT color="green">042</FONT>    import ch.javasoft.metabolic.efm.util.BitSetUtil;<a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.metabolic.efm.util.ModUtil;<a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.util.Arrays;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.util.IntArray;<a name="line.45"></a>
<FONT color="green">046</FONT>    <a name="line.46"></a>
<FONT color="green">047</FONT>    /**<a name="line.47"></a>
<FONT color="green">048</FONT>     * <a name="line.48"></a>
<FONT color="green">049</FONT>     */<a name="line.49"></a>
<FONT color="green">050</FONT>    public class ModPrimePreprocessedMatrix implements PreprocessedMatrix {<a name="line.50"></a>
<FONT color="green">051</FONT>            <a name="line.51"></a>
<FONT color="green">052</FONT>            private static final int[] PRIMES = initPrimes(1);<a name="line.52"></a>
<FONT color="green">053</FONT>            <a name="line.53"></a>
<FONT color="green">054</FONT>        private static class Data {<a name="line.54"></a>
<FONT color="green">055</FONT>            public Data(int[][] matrix, int rank, IBitSet unusedBits) {<a name="line.55"></a>
<FONT color="green">056</FONT>                this.matrix     = matrix;<a name="line.56"></a>
<FONT color="green">057</FONT>                this.rank       = rank;<a name="line.57"></a>
<FONT color="green">058</FONT>                this.unusedBits = unusedBits;<a name="line.58"></a>
<FONT color="green">059</FONT>            }<a name="line.59"></a>
<FONT color="green">060</FONT>            final int[][]                   matrix;<a name="line.60"></a>
<FONT color="green">061</FONT>            final int                               rank;<a name="line.61"></a>
<FONT color="green">062</FONT>            final IBitSet   unusedBits;<a name="line.62"></a>
<FONT color="green">063</FONT>            @Override<a name="line.63"></a>
<FONT color="green">064</FONT>                    public Data clone() {<a name="line.64"></a>
<FONT color="green">065</FONT>                return new Data(IntArray.clone(matrix), rank, unusedBits.clone());<a name="line.65"></a>
<FONT color="green">066</FONT>            }<a name="line.66"></a>
<FONT color="green">067</FONT>        }<a name="line.67"></a>
<FONT color="green">068</FONT>        <a name="line.68"></a>
<FONT color="green">069</FONT>        private final Data[] data;<a name="line.69"></a>
<FONT color="green">070</FONT>            <a name="line.70"></a>
<FONT color="green">071</FONT>            /**<a name="line.71"></a>
<FONT color="green">072</FONT>             * Constructor for cloneing<a name="line.72"></a>
<FONT color="green">073</FONT>             */<a name="line.73"></a>
<FONT color="green">074</FONT>            public ModPrimePreprocessedMatrix(ModPrimePreprocessedMatrix copyOf) {<a name="line.74"></a>
<FONT color="green">075</FONT>            data = new Data[copyOf.data.length];<a name="line.75"></a>
<FONT color="green">076</FONT>            for (int i = 0; i &lt; data.length; i++) {<a name="line.76"></a>
<FONT color="green">077</FONT>                data[i] = copyOf.data[i].clone();<a name="line.77"></a>
<FONT color="green">078</FONT>            }<a name="line.78"></a>
<FONT color="green">079</FONT>            }<a name="line.79"></a>
<FONT color="green">080</FONT>            /**<a name="line.80"></a>
<FONT color="green">081</FONT>             * Constructor for root matrix (has no parent)<a name="line.81"></a>
<FONT color="green">082</FONT>             */<a name="line.82"></a>
<FONT color="green">083</FONT>            public ModPrimePreprocessedMatrix(PreprocessableMatrix owner, RankUpdateRoot root) {<a name="line.83"></a>
<FONT color="green">084</FONT>                    final int stoichRank    = root.getStoichRank();<a name="line.84"></a>
<FONT color="green">085</FONT>                    final int[] colmap              = root.getColMapping();<a name="line.85"></a>
<FONT color="green">086</FONT>                    final IBitSet bits = BitSetUtil.factory().create(colmap.length);<a name="line.86"></a>
<FONT color="green">087</FONT>                    for (int i = 0; i &lt; colmap.length; i++) bits.set(i);<a name="line.87"></a>
<FONT color="green">088</FONT>    <a name="line.88"></a>
<FONT color="green">089</FONT>            data = new Data[PRIMES.length];<a name="line.89"></a>
<FONT color="green">090</FONT>            for (int i = 0; i &lt; data.length; i++) {<a name="line.90"></a>
<FONT color="green">091</FONT>                final IBitSet unused = bits.clone();<a name="line.91"></a>
<FONT color="green">092</FONT>                final int[][] matrix    = ModUtil.toIntArrayNoInversion(root.getStoichRational(), PRIMES[i]);<a name="line.92"></a>
<FONT color="green">093</FONT>                final int rank          = computeRank(matrix, i, stoichRank, stoichRank, 0, colmap, unused, unused, owner.nodeCutSet);<a name="line.93"></a>
<FONT color="green">094</FONT>                data[i] = new Data(matrix, rank, unused);<a name="line.94"></a>
<FONT color="green">095</FONT>            }<a name="line.95"></a>
<FONT color="green">096</FONT>            }<a name="line.96"></a>
<FONT color="green">097</FONT>            /**<a name="line.97"></a>
<FONT color="green">098</FONT>             * Constructor for child matrix (has parent)<a name="line.98"></a>
<FONT color="green">099</FONT>             */<a name="line.99"></a>
<FONT color="green">100</FONT>            public ModPrimePreprocessedMatrix(PreprocessableMatrix owner, RankUpdateRoot root, ModPrimePreprocessedMatrix parentProcessed) {                <a name="line.100"></a>
<FONT color="green">101</FONT>            data = new Data[PRIMES.length];<a name="line.101"></a>
<FONT color="green">102</FONT>            for (int i = 0; i &lt; data.length; i++) {<a name="line.102"></a>
<FONT color="green">103</FONT>                final IBitSet unused = parentProcessed.data[i].unusedBits.clone();<a name="line.103"></a>
<FONT color="green">104</FONT>                final int[][] matrix    = parentProcessed.data[i].matrix;<a name="line.104"></a>
<FONT color="green">105</FONT>                final int stoichRank    = root.getStoichRank();<a name="line.105"></a>
<FONT color="green">106</FONT>                final int[] colmap      = root.getColMapping();<a name="line.106"></a>
<FONT color="green">107</FONT>                final int rank = computeRank(matrix, i, stoichRank, stoichRank, parentProcessed.data[i].rank, colmap, unused, unused, owner.nodeCutSet);<a name="line.107"></a>
<FONT color="green">108</FONT>                data[i] = new Data(matrix, rank, unused);<a name="line.108"></a>
<FONT color="green">109</FONT>            }<a name="line.109"></a>
<FONT color="green">110</FONT>            }<a name="line.110"></a>
<FONT color="green">111</FONT>            <a name="line.111"></a>
<FONT color="green">112</FONT>            public boolean hasRequiredRank(RankUpRoot root, IBitSet intersectionSet) {<a name="line.112"></a>
<FONT color="green">113</FONT>                    final int stoichRank    = root.getStoichRank();<a name="line.113"></a>
<FONT color="green">114</FONT>                    final int reqRank               = root.getRequiredRank() - intersectionSet.cardinality();<a name="line.114"></a>
<FONT color="green">115</FONT>                    final int[] colmap              = root.getColMapping();<a name="line.115"></a>
<FONT color="green">116</FONT>                    return<a name="line.116"></a>
<FONT color="green">117</FONT>                            reqRank &lt;= getMaxRank() ||<a name="line.117"></a>
<FONT color="green">118</FONT>                            reqRank &lt;= computeRank(stoichRank, reqRank, colmap, intersectionSet);<a name="line.118"></a>
<FONT color="green">119</FONT>            }<a name="line.119"></a>
<FONT color="green">120</FONT>        <a name="line.120"></a>
<FONT color="green">121</FONT>        public int getMaxRank() {<a name="line.121"></a>
<FONT color="green">122</FONT>            int rank = 0;<a name="line.122"></a>
<FONT color="green">123</FONT>            for (int i = 0; i &lt; data.length; i++) {<a name="line.123"></a>
<FONT color="green">124</FONT>                rank = Math.max(rank, data[i].rank);<a name="line.124"></a>
<FONT color="green">125</FONT>            }<a name="line.125"></a>
<FONT color="green">126</FONT>            return rank;<a name="line.126"></a>
<FONT color="green">127</FONT>        }<a name="line.127"></a>
<FONT color="green">128</FONT>        @Override<a name="line.128"></a>
<FONT color="green">129</FONT>        public String toString() {<a name="line.129"></a>
<FONT color="green">130</FONT>            return "preprocessed(" + getMaxRank() + ")";<a name="line.130"></a>
<FONT color="green">131</FONT>        }<a name="line.131"></a>
<FONT color="green">132</FONT>            <a name="line.132"></a>
<FONT color="green">133</FONT>            @Override<a name="line.133"></a>
<FONT color="green">134</FONT>            public ModPrimePreprocessedMatrix clone() {<a name="line.134"></a>
<FONT color="green">135</FONT>                    return new ModPrimePreprocessedMatrix(this);<a name="line.135"></a>
<FONT color="green">136</FONT>            }<a name="line.136"></a>
<FONT color="green">137</FONT>            /**<a name="line.137"></a>
<FONT color="green">138</FONT>             * @param setToCompute  the columns to use are the unset bits<a name="line.138"></a>
<FONT color="green">139</FONT>             */<a name="line.139"></a>
<FONT color="green">140</FONT>            private int computeRank(int stoichRank, int stopRank, int[] fixcolmap, IBitSet setToCompute) {<a name="line.140"></a>
<FONT color="green">141</FONT>                    int maxRank = 0;<a name="line.141"></a>
<FONT color="green">142</FONT>                    for (int i = 0; i &lt; data.length; i++) {<a name="line.142"></a>
<FONT color="green">143</FONT>                            final int cur = computeRank(data[i].matrix, i, stoichRank, stopRank, data[i].rank, fixcolmap, data[i].unusedBits, null, setToCompute);<a name="line.143"></a>
<FONT color="green">144</FONT>                            if (stopRank &lt;= cur) return cur;<a name="line.144"></a>
<FONT color="green">145</FONT>                maxRank = Math.max(maxRank, cur);<a name="line.145"></a>
<FONT color="green">146</FONT>                    }<a name="line.146"></a>
<FONT color="green">147</FONT>                    return maxRank;<a name="line.147"></a>
<FONT color="green">148</FONT>            }<a name="line.148"></a>
<FONT color="green">149</FONT>            /**<a name="line.149"></a>
<FONT color="green">150</FONT>             * @param setToCompute  the columns to use are the unset bits<a name="line.150"></a>
<FONT color="green">151</FONT>             */<a name="line.151"></a>
<FONT color="green">152</FONT>            private static int computeRank(int[][] mx, int which, int stoichRank, int stopRank, int rank, int[] fixcolmap, IBitSet unusedBits, IBitSet unusedBitsOut, IBitSet setToCompute) {<a name="line.152"></a>
<FONT color="green">153</FONT>                    final int iprime = PRIMES[which];<a name="line.153"></a>
<FONT color="green">154</FONT>                    final int bits = fixcolmap.length;<a name="line.154"></a>
<FONT color="green">155</FONT>                    final int[] colmap = new int[bits];<a name="line.155"></a>
<FONT color="green">156</FONT>                    final int[] bitmap = new int[bits];<a name="line.156"></a>
<FONT color="green">157</FONT>                    <a name="line.157"></a>
<FONT color="green">158</FONT>    //              trace("all:unused-old:       set", bits, unusedBits, setToCompute);<a name="line.158"></a>
<FONT color="green">159</FONT>    <a name="line.159"></a>
<FONT color="green">160</FONT>                    //collect the newly usable columns              <a name="line.160"></a>
<FONT color="green">161</FONT>    //              int colsPre = 0;//already used for rank computation in previous step<a name="line.161"></a>
<FONT color="green">162</FONT>                    int colsAct = rank;//active columns, those which are used as pivots<a name="line.162"></a>
<FONT color="green">163</FONT>                    int colsPas = bits;//passive columns, those which are used not as pivots but for row operations<a name="line.163"></a>
<FONT color="green">164</FONT>                    for (int bit = unusedBits.nextSetBit(0); bit &gt;= 0; bit = unusedBits.nextSetBit(bit + 1)) {<a name="line.164"></a>
<FONT color="green">165</FONT>                            if (!setToCompute.get(bit)) {<a name="line.165"></a>
<FONT color="green">166</FONT>                                    bitmap[colsAct] = bit;<a name="line.166"></a>
<FONT color="green">167</FONT>                                    colmap[colsAct] = fixcolmap[bit];<a name="line.167"></a>
<FONT color="green">168</FONT>                                    colsAct++;<a name="line.168"></a>
<FONT color="green">169</FONT>                            }<a name="line.169"></a>
<FONT color="green">170</FONT>                            else {<a name="line.170"></a>
<FONT color="green">171</FONT>                                    colsPas--;<a name="line.171"></a>
<FONT color="green">172</FONT>                                    colmap[colsPas] = fixcolmap[bit];<a name="line.172"></a>
<FONT color="green">173</FONT>                            }<a name="line.173"></a>
<FONT color="green">174</FONT>                    }<a name="line.174"></a>
<FONT color="green">175</FONT>    //              if (rank != colsPre) throw new RuntimeException("internal error, rank should be same as used: " + rank + "!=" + colsPre);<a name="line.175"></a>
<FONT color="green">176</FONT>                    if (colsPas != colsAct) throw new RuntimeException("internal error, colsPas should be same as colsAct: " + colsPas + "!=" + colsAct);<a name="line.176"></a>
<FONT color="green">177</FONT>                    final int colsTot = bits;<a name="line.177"></a>
<FONT color="green">178</FONT>                    <a name="line.178"></a>
<FONT color="green">179</FONT>                    //now, compute the new rank stuff (copied from Gauss() in common-util)<a name="line.179"></a>
<FONT color="green">180</FONT>                    final int rows = mx.length;<a name="line.180"></a>
<FONT color="green">181</FONT>                    final int pivs = Math.min(stopRank, Math.min(rows, colsAct));           <a name="line.181"></a>
<FONT color="green">182</FONT>                    <a name="line.182"></a>
<FONT color="green">183</FONT>                    for (int ipiv = rank; ipiv &lt; pivs; ipiv++) {<a name="line.183"></a>
<FONT color="green">184</FONT>                            //find pivot row/column<a name="line.184"></a>
<FONT color="green">185</FONT>                            int prow        = ipiv;<a name="line.185"></a>
<FONT color="green">186</FONT>                            int picol       = ipiv;<a name="line.186"></a>
<FONT color="green">187</FONT>                            int pval        = 0;<a name="line.187"></a>
<FONT color="green">188</FONT>                            //first, just try this column, then all columns<a name="line.188"></a>
<FONT color="green">189</FONT>                            for (int icol = ipiv; icol &lt; colsAct &amp;&amp; pval == 0; icol++) {<a name="line.189"></a>
<FONT color="green">190</FONT>                                    for (int row = ipiv; row &lt; rows &amp;&amp; pval == 0; row++) {<a name="line.190"></a>
<FONT color="green">191</FONT>                                            final int col = colmap[icol];<a name="line.191"></a>
<FONT color="green">192</FONT>                                            prow   = row;<a name="line.192"></a>
<FONT color="green">193</FONT>                        picol  = icol; <a name="line.193"></a>
<FONT color="green">194</FONT>                                            pval   = mx[row][col];<a name="line.194"></a>
<FONT color="green">195</FONT>                                    }<a name="line.195"></a>
<FONT color="green">196</FONT>                            }<a name="line.196"></a>
<FONT color="green">197</FONT>                                                    <a name="line.197"></a>
<FONT color="green">198</FONT>                            if (pval == 0) {<a name="line.198"></a>
<FONT color="green">199</FONT>                                    return ipiv;<a name="line.199"></a>
<FONT color="green">200</FONT>                            }                       <a name="line.200"></a>
<FONT color="green">201</FONT>                            <a name="line.201"></a>
<FONT color="green">202</FONT>                            //swap rows / columns<a name="line.202"></a>
<FONT color="green">203</FONT>                            if (prow != ipiv) {<a name="line.203"></a>
<FONT color="green">204</FONT>                                    Arrays.swap(mx, prow, ipiv);<a name="line.204"></a>
<FONT color="green">205</FONT>                            }<a name="line.205"></a>
<FONT color="green">206</FONT>                            if (picol != ipiv) {<a name="line.206"></a>
<FONT color="green">207</FONT>                                    IntArray.swap(colmap, picol, ipiv);<a name="line.207"></a>
<FONT color="green">208</FONT>                                    IntArray.swap(bitmap, picol, ipiv);<a name="line.208"></a>
<FONT color="green">209</FONT>                            }<a name="line.209"></a>
<FONT color="green">210</FONT>                            if (unusedBitsOut != null) {<a name="line.210"></a>
<FONT color="green">211</FONT>                                    unusedBitsOut.clear(bitmap[ipiv]);<a name="line.211"></a>
<FONT color="green">212</FONT>                            }<a name="line.212"></a>
<FONT color="green">213</FONT>                            <a name="line.213"></a>
<FONT color="green">214</FONT>                            final int pivrow = ipiv;<a name="line.214"></a>
<FONT color="green">215</FONT>                            final int pivcol = colmap[ipiv];<a name="line.215"></a>
<FONT color="green">216</FONT>                            <a name="line.216"></a>
<FONT color="green">217</FONT>                            //subtract pivot row from other rows<a name="line.217"></a>
<FONT color="green">218</FONT>                            final int[] prowvals = mx[pivrow];<a name="line.218"></a>
<FONT color="green">219</FONT>                            for (int row = ipiv + 1; row &lt; rows; row++) {<a name="line.219"></a>
<FONT color="green">220</FONT>                                    final long rpiv = mx[row][pivcol];<a name="line.220"></a>
<FONT color="green">221</FONT>                                    mx[row][pivcol] = 0;<a name="line.221"></a>
<FONT color="green">222</FONT>                    for (int icol = ipiv + 1; icol &lt; colsTot; icol++) {<a name="line.222"></a>
<FONT color="green">223</FONT>                        final int col = colmap[icol];<a name="line.223"></a>
<FONT color="green">224</FONT>                        <a name="line.224"></a>
<FONT color="green">225</FONT>                        //prime is 2^31-k, thus prime*prime &lt; 2^62.<a name="line.225"></a>
<FONT color="green">226</FONT>                        //thus a*b-c*d &lt; 2^63, thus modulo at end only is ok<a name="line.226"></a>
<FONT color="green">227</FONT>                        final long old = mx[row][col];<a name="line.227"></a>
<FONT color="green">228</FONT>                                            final long val = (old * pval - prowvals[col] * rpiv) % iprime;<a name="line.228"></a>
<FONT color="green">229</FONT>                                            mx[row][col] = (int)val;<a name="line.229"></a>
<FONT color="green">230</FONT>                        <a name="line.230"></a>
<FONT color="green">231</FONT>    //                                      final int sub  = mx[pivrow][col];<a name="line.231"></a>
<FONT color="green">232</FONT>    //                    mx[row][col]   = mul(mx[row][col], pval, iprime);<a name="line.232"></a>
<FONT color="green">233</FONT>    //                    mx[row][col]   = sub(mx[row][col], mul(sub, rpiv, iprime), iprime);<a name="line.233"></a>
<FONT color="green">234</FONT>                                    }<a name="line.234"></a>
<FONT color="green">235</FONT>                            }<a name="line.235"></a>
<FONT color="green">236</FONT>                    }<a name="line.236"></a>
<FONT color="green">237</FONT>    //              trace("rank=" + pivs + ":unused-new", bits, unusedBits);<a name="line.237"></a>
<FONT color="green">238</FONT>                    return pivs;<a name="line.238"></a>
<FONT color="green">239</FONT>            }<a name="line.239"></a>
<FONT color="green">240</FONT>    <a name="line.240"></a>
<FONT color="green">241</FONT>            private static int[] initPrimes(int cnt) {<a name="line.241"></a>
<FONT color="green">242</FONT>                    int[] primes = new int[cnt];<a name="line.242"></a>
<FONT color="green">243</FONT>                    for (int i = 0; i &lt; primes.length; i++) {<a name="line.243"></a>
<FONT color="green">244</FONT>                            primes[i] = Prime.getPrime31(i);<a name="line.244"></a>
<FONT color="green">245</FONT>                    }<a name="line.245"></a>
<FONT color="green">246</FONT>                    return primes;<a name="line.246"></a>
<FONT color="green">247</FONT>            }       <a name="line.247"></a>
<FONT color="green">248</FONT>    }<a name="line.248"></a>




























































</PRE>
</BODY>
</HTML>
